%define anolis_release 1

%global debug_package %{nil}

# https://bugzilla.redhat.com/show_bug.cgi?id=995136#c12
%global _dwz_low_mem_die_limit 0

%global DOMAIN github.com
%global ORG dragonflyoss
%global PROJECT Dragonfly
%global IMPORTNAME %{DOMAIN}/%{ORG}/%{PROJECT}

%define gobuild(o:) go build -ldflags "${LDFLAGS:-} -B 0x$(head -c20 /dev/urandom|od -An -tx1|tr -d ' \\n')" -a -v -x %{?**};

Name:		Dragonfly
Version:	1.0.6
Release:	%{anolis_release}%{?dist}
Summary:	An intelligent P2P based image and file distribution system

License:	ASL 2.0
URL:		https://codeup.openanolis.cn/codeup/projects/Dragonfly
Source0:        %{name}-%{version}.tar.gz
Source1:	dragonfly.conf
Source2:	nginx.conf
Source3:        supernode.service
ExclusiveArch: x86_64
BuildRequires: %{?go_compiler:compiler(go-compiler)}%{!?go_compiler:golang}
BuildRequires: systemd

%description
Dragonfly is an intelligent P2P based image and file distribution system.

%global GO_ROOT /usr/lib/golang/
%global GO_SRC  src/%{IMPORTNAME}

%package client
Summary: Dragonfly client (dfget and dfdaemon)

%description client
dfget is the client of Dragonfly. You can use the dfget command in the command
line tool.

dfdaemon is a key component of solution for distributing images, it is a
resident process, which can be used either as registry-mirror or as a
docker proxy.


%package supernode
Summary: Dragonfly Cluster Manager(Supernode)
Requires: nginx

%description supernode
Dragonfly Cluster Manager(Supernode) is the P2P server, which is mainly
responsible for scheduling P2P task and making CDN cache.


%prep
%setup -q -T -c
mkdir -p %{GO_SRC}
tar xzf %{SOURCE0} --strip-component 1 -C %{GO_SRC}

%build
cd %{GO_SRC}
export GOPROXY="https://mirrors.aliyun.com/goproxy,direct"
export GOROOT=%{GO_ROOT}
export GOPATH=%{_builddir}/%{name}-%{version}
export LDFLAGS="-X %{IMPORTNAME}/version.Version=%{version}"
%gobuild -o "out/supernode" cmd/supernode/main.go
%gobuild -o "out/dfget" cmd/dfget/main.go
%gobuild -o "out/dfdaemon" cmd/dfdaemon/main.go


%check
cd %{GO_SRC}
export GOPROXY="https://mirrors.aliyun.com/goproxy,direct"
export GOROOT=%{GO_ROOT}
export GOPATH=%{_builddir}/%{name}-%{version}
# FIXME: not working?
make unit-test

%install
cd %{GO_SRC}
mkdir -p %{buildroot}%{_bindir}
install -m0755 out/supernode %{buildroot}%{_bindir}
install -m0755 out/dfget %{buildroot}%{_bindir}
install -m0755 out/dfdaemon %{buildroot}%{_bindir}
mkdir -p %{buildroot}%{_sysconfdir}
install -m0644 %{SOURCE1} %{buildroot}%{_sysconfdir}/dragonfly.conf
mkdir -p %{buildroot}%{_sysconfdir}/nginx/conf.d/
install -m0644 %{SOURCE2} %{buildroot}%{_sysconfdir}/nginx/conf.d/supernode.conf
mkdir -p %{buildroot}%{_unitdir}
install -m0644 %{SOURCE3} %{buildroot}%{_unitdir}/supernode.service
mkdir -p %{buildroot}%{_sharedstatedir}/supernode/repo

%files supernode
%license %{GO_SRC}/LICENSE
%doc %{GO_SRC}/README.md %{GO_SRC}/CHANGELOG.md %{GO_SRC}/CONTRIBUTORS
%dir %{_sharedstatedir}/supernode/repo
%config(noreplace) %{_sysconfdir}/nginx/conf.d/supernode.conf
%{_bindir}/supernode
%{_unitdir}/supernode.service

%files client
%license %{GO_SRC}/LICENSE
%doc %{GO_SRC}/README.md %{GO_SRC}/CHANGELOG.md %{GO_SRC}/CONTRIBUTORS
%{_bindir}/dfget
%{_bindir}/dfdaemon
%config(noreplace) %{_sysconfdir}/dragonfly.conf

%changelog
* Tue Jun  8 2021 Liwei Ge <geliwei@openanolis.org> - 1.0.6-1
- Init version of 1.0.6

